"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _react = _interopRequireDefault(require("react"));

var _useSearch = require("../../hooks/useSearch");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _default(Component) {
  var Wrapper = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    var _props$noGenerateAuto = props.noGenerateAutoSearch,
        noGenerateAutoSearch = _props$noGenerateAuto === void 0 ? false : _props$noGenerateAuto,
        inputSearchData = props.searchData,
        other = _objectWithoutProperties(props, ["noGenerateAutoSearch", "searchData"]);

    var _React$useState = _react.default.useState(inputSearchData ? new Set(inputSearchData) : new Set()),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        searchData = _React$useState2[0],
        setSearchData = _React$useState2[1];

    var addSearchItem = function addSearchItem(item) {
      return !noGenerateAutoSearch && setSearchData(function (prev) {
        var newData = new Set(prev);
        newData.add(item);
        return newData;
      });
    };

    var removeSearchItem = function removeSearchItem(item) {
      return !noGenerateAutoSearch && setSearchData(function (prev) {
        var newData = new Set(prev);
        newData.delete(item);
        return newData;
      });
    };

    var getSearchData = function getSearchData() {
      return _toConsumableArray(searchData);
    };

    return /*#__PURE__*/_react.default.createElement(_useSearch.SearchContext.Provider, {
      value: {
        addSearchItem: addSearchItem,
        removeSearchItem: removeSearchItem,
        getSearchData: getSearchData
      }
    }, /*#__PURE__*/_react.default.createElement(Component, _extends({}, other, {
      ref: ref,
      getSearchData: getSearchData
    })));
  });

  return Wrapper;
}