"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _reactLazyLoadImageComponent = require("react-lazy-load-image-component");

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _styles2 = require("@material-ui/styles");

var _Box = _interopRequireDefault(require("@material-ui/core/Box"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-Image";
exports.displayName = displayName;

var Image = /*#__PURE__*/_react.default.forwardRef(function Image(props, ref) {
  var _props$src = props.src,
      src = _props$src === void 0 ? "" : _props$src,
      _props$alt = props.alt,
      alt = _props$alt === void 0 ? "" : _props$alt,
      placeholderSrc = props.placeholderSrc,
      style = props.style,
      className = props.className,
      children = props.children,
      _props$fullWidth = props.fullWidth,
      fullWidth = _props$fullWidth === void 0 ? false : _props$fullWidth,
      _props$frame = props.frame,
      frame = _props$frame === void 0 ? false : _props$frame,
      _props$align = props.align,
      align = _props$align === void 0 ? "left" : _props$align,
      classes = props.classes,
      other = _objectWithoutProperties(props, ["src", "alt", "placeholderSrc", "style", "className", "children", "fullWidth", "frame", "align", "classes"]);

  var _React$useState = _react.default.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      loaded = _React$useState2[0],
      setLoaded = _React$useState2[1];

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    style: _objectSpread({
      minHeight: loaded ? 0 : 200
    }, style),
    className: (0, _clsx.default)(classes.root, fullWidth && classes.fullWidth, frame && classes.frame, className, align === "right" && classes.alignRight, align === "center" && classes.alignCenter),
    ref: ref
  }, /*#__PURE__*/_react.default.createElement(_reactLazyLoadImageComponent.LazyLoadImage, {
    alt: alt,
    style: {
      width: "100%"
    },
    src: src,
    placeholderSrc: placeholderSrc || src,
    effect: "blur",
    wrapperClassName: (0, _clsx.default)(fullWidth && classes.fullWidth),
    afterLoad: function afterLoad() {
      return setLoaded(true);
    }
  }), !loaded && /*#__PURE__*/_react.default.createElement(_Box.default, {
    className: (0, _clsx.default)(classes.placeholder),
    style: {
      opacity: placeholderSrc ? 0.4 : 1
    }
  }, /*#__PURE__*/_react.default.createElement(_CircularProgress.default, {
    className: classes.progress,
    size: 70
  }))), children && /*#__PURE__*/_react.default.createElement(_Typography.default, {
    color: "textSecondary",
    variant: "subtitle2",
    paragraph: false
  }, children));
});

Image.displayName = displayName;
Image.propTypes = {
  // ImageProps
  src: _propTypes.default.string,
  placeholderSrc: _propTypes.default.string,
  alt: _propTypes.default.string,
  fullWidth: _propTypes.default.bool,
  frame: _propTypes.default.bool,
  align: _propTypes.default.oneOf(["left", "center", "right"]),
  // Stylable
  style: _propTypes.default.object,
  className: _propTypes.default.string,
  classes: _propTypes.default.object,
  // Containerable
  children: _propTypes.default.node
};

var _default = (0, _styles2.withStyles)(_styles.styles, {
  name: displayName
})(Image);

exports.default = _default;