"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("./styles");

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _Menu = _interopRequireDefault(require("@material-ui/core/Menu"));

var _KeyboardArrowDown = _interopRequireDefault(require("@material-ui/icons/KeyboardArrowDown"));

var _Translate = _interopRequireDefault(require("@material-ui/icons/Translate"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useLang2 = _interopRequireDefault(require("../../hooks/useLang"));

var _clsx = _interopRequireDefault(require("clsx"));

var _styles2 = require("@material-ui/styles");

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var displayName = "MaterialDocs-LanguageSelector";
exports.displayName = displayName;

var LanguageSelector = /*#__PURE__*/_react.default.forwardRef(function LanguageSelector(props, _ref) {
  var className = props.className,
      style = props.style,
      _props$size = props.size,
      size = _props$size === void 0 ? "large" : _props$size,
      classes = props.classes,
      other = _objectWithoutProperties(props, ["className", "style", "size", "classes"]);

  var _useLang = (0, _useLang2.default)(),
      langs = _useLang.langs,
      lang = _useLang.lang,
      switchLang = _useLang.switchLang,
      onHelpToTranslate = _useLang.onHelpToTranslate;

  var _React$useState = _react.default.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      opened = _React$useState2[0],
      setOpened = _React$useState2[1];

  var buttonRef = _react.default.useRef(null);

  if (onHelpToTranslate && typeof onHelpToTranslate !== "function") throw new TypeError("MaterialDocs: incorrect type of onHelpToTranslate, expected function, got ".concat(_typeof(onHelpToTranslate)));
  if (!lang) return null;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    title: (0, _utils.getFieldFromLang)(lang, "MaterialDocs/tooltips/selectLanguage"),
    PopperProps: {
      popperOptions: {
        positionFixed: true
      }
    }
  }, /*#__PURE__*/_react.default.createElement(_Button.default, {
    className: (0, _clsx.default)(classes.root.className),
    color: "inherit",
    ref: function ref(reference) {
      buttonRef.current = reference;
      _ref = reference;
    },
    onClick: function onClick(event) {
      return setOpened(true);
    },
    style: style
  }, /*#__PURE__*/_react.default.createElement(_Translate.default, null), size === "large" && lang.label, /*#__PURE__*/_react.default.createElement(_KeyboardArrowDown.default, null))), /*#__PURE__*/_react.default.createElement(_Menu.default, {
    anchorEl: buttonRef.current,
    getContentAnchorEl: null,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: 'left'
    },
    keepMounted: true,
    open: opened,
    onClose: function onClose(event) {
      return setOpened(false);
    }
  }, Array.isArray(langs) && langs.map(function (item) {
    return /*#__PURE__*/_react.default.createElement(_MenuItem.default, {
      key: item.name,
      onClick: function onClick(event) {
        switchLang(item).then();
        setOpened(false);
      },
      selected: item.name === lang.name
    }, item.label);
  }), onHelpToTranslate && /*#__PURE__*/_react.default.createElement(_Divider.default, null), onHelpToTranslate && /*#__PURE__*/_react.default.createElement(_MenuItem.default, {
    onClick: onHelpToTranslate
  }, "Help to translate")));
});

LanguageSelector.displayName = displayName;
LanguageSelector.propTypes = {
  size: _propTypes.default.oneOf(["small", "large"]),
  // Stylable
  style: _propTypes.default.object,
  className: _propTypes.default.string,
  classes: _propTypes.default.object
};

var _default = (0, _styles2.withStyles)(_styles.styles, {
  name: displayName
})(LanguageSelector);

exports.default = _default;