"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SwitchPageContext = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
var SwitchPageContext = /*#__PURE__*/_react.default.createContext({
  switchPage: function switchPage(page) {},
  currentPage: null
});

exports.SwitchPageContext = SwitchPageContext;

var useSwitchPage = function useSwitchPage() {
  return _react.default.useContext(SwitchPageContext);
};

var _default = useSwitchPage;
exports.default = _default;