"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.TaggingContext = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
var TaggingContext = /*#__PURE__*/_react.default.createContext({
  setTag: function setTag(key, value) {},
  removeTag: function removeTag(key) {},
  tags: {}
});

exports.TaggingContext = TaggingContext;

var useTags = function useTags() {
  return _react.default.useContext(TaggingContext);
};

var _default = useTags;
exports.default = _default;