"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _colors = require("@material-ui/core/colors");

var _AutoDocsMenu = require("./../components/AutoDocsMenu");

var _Block = require("./../components/Block");

var _Bold = require("./../components/Bold");

var _Code = require("./../components/Code");

var _CodeSpan = require("./../components/CodeSpan");

var _DemoWithCode = require("./../components/DemoWithCode");

var _DocsMenu = require("./../components/DocsMenu");

var _DocsMenuItem = require("./../components/DocsMenuItem");

var _DocsPage = require("./../components/DocsPage");

var _NavigationList = require("./../components/DocsPage/NavigationList");

var _DocsPages = require("./../components/DocsPages");

var _ExpansionCode = require("./../components/ExpansionCode");

var _H = require("./../components/H1");

var _H2 = require("./../components/H2");

var _H3 = require("./../components/H3");

var _H4 = require("./../components/H4");

var _H5 = require("./../components/H5");

var _H6 = require("./../components/H6");

var _Header = require("./../components/Header");

var _Image = require("./../components/Image");

var _Italic = require("./../components/Italic");

var _Landing = require("./../components/Landing");

var _LanguageSelector = require("./../components/LanguageSelector");

var _List = require("./../components/List");

var _ListItem = require("./../components/ListItem");

var _ListItemContained = require("./../components/ListItemContained");

var _Markdown = require("./../components/Markdown");

var _PagesGroup = require("./../components/PagesGroup");

var _SearchField = require("./../components/SearchField");

var _SearchMenuItem = require("./../components/SearchField/SearchMenuItem");

var _Table = require("./../components/Table");

var _Tagable = require("./../components/Tagable");

var _components;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DefaultTheme = {
  palette: {
    primary: {
      main: _colors.blue[700],
      dark: _colors.blueGrey[900]
    },
    secondary: {
      main: _colors.red[600]
    },
    whitesmoke: {
      main: _colors.grey[200],
      dark: _colors.grey[800]
    },
    lightgrey: {
      main: _colors.grey[300],
      dark: _colors.grey[700]
    },
    codeSpanBg: {
      main: _colors.yellow[100],
      dark: _colors.grey[700]
    }
  },
  components: (_components = {}, _defineProperty(_components, _AutoDocsMenu.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _Block.displayName, {
    defaultProps: {
      color: "light"
    }
  }), _defineProperty(_components, _Bold.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _Code.displayName, {
    defaultProps: {
      language: "javascript",
      theme: "light"
    }
  }), _defineProperty(_components, _CodeSpan.displayName, {
    defaultProps: {
      color: "default",
      text: "inherit"
    }
  }), _defineProperty(_components, _DemoWithCode.displayName, {
    defaultProps: {
      noTag: false,
      paperContainer: false,
      p: 0,
      m: 0
    }
  }), _defineProperty(_components, _DocsMenu.displayName, {
    defaultProps: {
      dense: false
    }
  }), _defineProperty(_components, _DocsMenuItem.displayName, {
    defaultProps: {
      defaultExpanded: false,
      textPrimary: "",
      textSecondary: "",
      isCurrent: false,
      dense: false
    }
  }), _defineProperty(_components, _DocsPage.displayName, {
    defaultProps: {
      name: "home",
      noGenerateAutoSearch: false,
      noAutoMenu: false,
      searchTags: []
    }
  }), _defineProperty(_components, _NavigationList.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _DocsPages.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _ExpansionCode.displayName, {
    defaultProps: {
      collapsedHeight: 100
    }
  }), _defineProperty(_components, _H.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _H2.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _H3.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _H4.displayName, {
    defaultProps: {
      noDivider: true,
      noTag: true
    }
  }), _defineProperty(_components, _H5.displayName, {
    defaultProps: {
      noDivider: true,
      noTag: true
    }
  }), _defineProperty(_components, _H6.displayName, {
    defaultProps: {
      noDivider: true,
      noTag: true
    }
  }), _defineProperty(_components, _Header.displayName, {
    defaultProps: {
      heading: 1
    }
  }), _defineProperty(_components, _Image.displayName, {
    defaultProps: {
      src: "",
      alt: "",
      fullWidth: false
    }
  }), _defineProperty(_components, _Italic.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _Landing.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _LanguageSelector.displayName, {
    defaultProps: {
      size: "large"
    }
  }), _defineProperty(_components, _List.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _ListItem.displayName, {
    defaultProps: {
      type: "circle",
      dense: false
    }
  }), _defineProperty(_components, _ListItemContained.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _Markdown.displayName, {
    defaultProps: {
      inline: false,
      data: {}
    }
  }), _defineProperty(_components, _PagesGroup.displayName, {
    defaultProps: {},
    defaultExpanded: false
  }), _defineProperty(_components, _SearchField.displayName, {
    defaultProps: {
      searchData: []
    }
  }), _defineProperty(_components, _SearchMenuItem.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _Table.displayName, {
    defaultProps: {}
  }), _defineProperty(_components, _Tagable.displayName, {
    defaultProps: {
      noTag: false,
      noDivider: false
    }
  }), _components)
};
var _default = DefaultTheme;
exports.default = _default;