"use strict";

var _mergeLangs = _interopRequireDefault(require("./mergeLangs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
describe("Utils -> mergeLangs", function () {
  test("Testing locales merging", function () {
    var defaultLocale = {
      name: "en-us",
      label: "English",
      locale: {
        words: {
          hello: "hello",
          darkness: "darkness"
        }
      }
    };
    var translationLocale = {
      name: "ru-ru",
      label: "Русский",
      locale: {
        words: {
          darkness: "тьма",
          my: "моя"
        }
      }
    };
    var expectedLocale = {
      name: "ru-ru",
      label: "Русский",
      locale: {
        words: {
          hello: "hello",
          darkness: "тьма",
          my: "моя"
        }
      }
    };
    expect((0, _mergeLangs.default)(translationLocale, defaultLocale)).toEqual(expectedLocale);
  });
});