"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.demoCodeActionValidate = demoCodeActionValidate;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _createChainableTypeChecker = _interopRequireDefault(require("../utils/createChainableTypeChecker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * demoCodeActionValidate - type validator for DemoCodeAction interface.
 * @function
 * @param {object} props
 * @param {string} propName
 * @param {string} componentName
 * @returns Error
 */
function demoCodeActionValidate(prop, propName, componentName) {
  if (! /*#__PURE__*/_react.default.isValidElement(prop.icon)) return Error("Incorrect field 'icon' type on prop ".concat(propName, " in component ").concat(componentName, ", expected \"node\", got \"").concat(_typeof(prop.icon), "\""));
  if (!prop.link && !prop.onClick) return Error("You must specify one of these fields: link, onClick!");
  if (prop.link && !(typeof prop.link === "string" || _typeof(prop.link) === "object")) return Error("Incorrect field 'link' type on prop ".concat(propName, " in component ").concat(componentName, ", expected \"string | object\", got \"").concat(_typeof(prop.link), "\""));
  if (prop.onClick && typeof prop.onClick !== "function") return Error("Incorrect field 'onClick' type on prop ".concat(propName, " in component ").concat(componentName, ", expected \"function(event: any): void\", got \"").concat(_typeof(prop.onClick), "\""));
  if (typeof prop.tooltip !== "string") return Error("Incorrect field 'tooltip' type on prop ".concat(propName, " in component ").concat(componentName, ", expected \"string\", got \"").concat(_typeof(prop.tooltip), "\""));
}

function DemoCodeActionValidator(props, propName, componentName) {
  var prop = props[propName];
  if (!prop) return null;
  return demoCodeActionValidate(prop, propName, componentName);
}
/**
 * DemoCodeActionValidator - PropTypes validator for DemoCodeAction interface.
 */


var _default = (0, _createChainableTypeChecker.default)(DemoCodeActionValidator);

exports.default = _default;